import random
import subprocess
import time
import requests
import json
import tls_client
from bson import ObjectId
import hashlib
from pymongo import MongoClient

def md5(text):
    m = hashlib.md5()
    m.update(text.encode())
    return m.hexdigest()

# 连接MongoDB数据库
client = MongoClient('mongodb://lcc-spider:JIUsfhiad&^@18.144.59.80:27017/?authSource=admin&directConnection=true')
db = client.env

# 查询所有文档
# result = db.env_shape.find()
# data = {str(x['_id']): x['env'] for x in result}
# print(result)
# with open('env.json', 'w') as f:
#     f.write(json.dumps(data))
with open('env.json', 'r') as f:
    data = json.loads(f.read())
envs = data.keys()


# session = requests.session()
headers = {
    "Host": "jbrest.jetblue.com",
    "application-channel": "Desktop_Web",
    "user-agent": "Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_7) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/114.0.0.0 Safari/537.36",
    "booking-application-type": "NGB",
    "content-type": "application/json",
    "accept": "application/json",
    "origin": "https://www.jetblue.com",
    "accept-language": "en-US,en;q=0.9,zh-CN;q=0.8,zh;q=0.7"
}

lastHash = ''
usedTime = 10
code = open('src.js', 'r').read()
for i in range(100):
    selectId = random.choice(list(envs))
    # selectId = 'ac22733c38ee66a568f17174'
    c = requests.get('https://www.jetblue.com/js/src/jb-74873.js').text
    m5 = md5(c)
    if m5 != lastHash and usedTime > 3:
        lastHash = m5
        usedTime = 0
        print('js变化')
        with open('src_run1.js', 'w') as f:
            f.write(code + '\n\n' + c)
    t1 = time.time()
    # r = requests.get('http://127.0.0.1:5000/getinfo').json()['message']
    # r = requests.get('http://127.0.0.1:3001').json()
    p = subprocess.Popen(['node', 'js_dom_run.js', selectId], stdin=subprocess.PIPE, stdout=subprocess.PIPE,
    # p = subprocess.Popen(['node', 'src_run1.js', selectId], stdin=subprocess.PIPE, stdout=subprocess.PIPE,
                         stderr=subprocess.PIPE)
    output, err = p.communicate(timeout=10)
    tmp = ''
    if p.returncode == 0:
        tmp = output.decode().split('\n')[-2]
    else:
        raise Exception("执行js失败")
    r = json.loads(tmp)
    res = db.env_shape.update_one(
        {'_id': ObjectId(selectId)},
        {"$inc": {"used": 1}}
    )
    usedTime += 1
    # r = {
    #     'X-1ItxWO9i-f': 'A7AKCbCJAQAAV93ahgnafaQIeEbvT-Ss7YkuAnwrNQi_E70IpAViSqhv3hLLAXL3RNiucirJwH9eCOfvosJeCA==',
    #     'X-1ItxWO9i-b': 'ewccp4',
    #     'X-1ItxWO9i-c': 'AKCIBbCJAQAAS49omJTgh_xmMwEfBsrVp1YYkI8f220xulUiHYixjnAeo_QF',
    #     'X-1ItxWO9i-d': 'ABaAhIjBCKHFgQGAAYIQgISi0aIA5JmBzvpDzz8AiLGOcB6j9AUAAAAAH29cNgBtJjAn30tmJD3CX2Js9F6q',
    #     'X-1ItxWO9i-z': 'q',
    #     'X-1ItxWO9i-a': 'IITLWFHmQerDGgV_F-9JVb=WQYLTPbk9yB1YUZmru1B4rURHS47KiOJ0fM_Fp6eFMI1Pw6M_5byMEKue9iCeQQ7azJzFZjbzQ0FlOjOBkDC9q150qoOJZmmZH94BDn8yTc6k5Djb4aUDjZH4DrkKdI2B_p95P_c4tX8MK5eCXM7CTVrCaRU255c9F7TPvkry5eV0knpyTnEMPo4ZEoLoZd6ag2iKgp-cPy1x802X1mQFd6LAsptii=u3iCA72Fu_UzssiYw0bWgyySfjGwW1UHny4zoU83R4eqRmYD1-n55l4cOw2em4h3xZ4flkAzT-pdmnQtmAFPc-br4S=sS=V=3tPzbsFGxBYR0H4ExqxriIgsVUy0jHmSHyZPSI7lGFZEBAMW_ji68UXEefoDcSUnvJyJFWxrCjLBSEayca1z7r_4w22LwjSbpDtjHLEQtgJrXmop4phcssVi7yLKp1ZvOUhWrmq13yGt8KSJv87CVOwxsXSBXIbc=RCnL2WYJjP5X1xaPRiOiVSHRAI9tudxwF7t3nZPDoQv_F6Fft18aiZFfBOEq9qkVVqTHpqDrJqODgVU4Ei9LurXmuhvmaUDzzDxMQye4aq2=GPQ_r28gY-oJs9rgKg3wEXAQO8Vao=vVEeTaYAGAZGH65T=UhEjr0Z=KiSP3=eZJlYdQ2QV9jdDZylwjj_r4avlv3A3n7mLt_hcnGE8uVSiypXG0730n-mEZ5CJk=e08udaqXijmx=TxfhoxgVh0fTMvx_jbOs6UJoA9vo-OY5hr=uj3b48dfjyySeHbCD-CFvz3QpgXiU6G6kpXAWXwv-xZtYAaw3XGCfkqoZ4cz5jLCUjYEEL3vzVf9dMiWGkk4RjHro6mRw9x=yZieyP8IVI=zoxZ8fMZTxXWvovpYvOAaCfyDMSe8ULjqDeFTnKuUlnMF8u6mhDwwh3co1DllqO2h11cd=M05OE91yMdB9l3vm6dbw0=JvHCTEi1Y_=2GcUPinRqzx6D2Mzb483ML2exPLrf6Og4HJ5UhWqFP8U-KXYhMeeLIn64069bCv3Fv2yfuHaieVrw_sp59TlWWfohsm32fLB64Hbw6C9tBYOaw7s6zF-V5gj9K-cE6e-RceM6n7tYR6qSkv1RFsK0rhBiy0=EIsV2BvARaQoTx_DzF-CBRVOUbtlyCfe8lA3xePq=Jk-JqXpSEMmXYfWlngYAOe69EWudOxLtqL8FtJq91v0sc9xk1R7X=k=j01PTR-74qEzS=9vxsZqPJjIn2aM5Vl9vag2eSEsBbL_WK_W9Q7BGQPi=iWjtDV6HfZSJYJojo5QieDe4b0KMg_8lU75I2yiX=J9Us-ebslQO=kX9i=Lojz1ea30jYfjlQaYEP7WXeklBY6rnvyxTYia_=h7kMKcQiogZOyAoOyjwbBFFSGOczdwCmd9FrFT5nAd7vf2my-wmf3FK4BD-BEF=DUMT2zUfc6PIL3=ovazFqJjJ2kBnAT9hwayqw56eYZTaPZRL'
    # }

    headers.update(r)
    print(f'{(time.time() - t1) *1000:.3f}ms', len(headers['X-1ItxWO9i-a'.lower()]))
    print(selectId, headers['user-agent'])
    url = "https://jbrest.jetblue.com/lfs-rwb/outboundLFS"
    data = {
        "tripType": "oneWay",
        "from": "LAS",
        "to": "BOS",
        "depart": "2023-10-10",
        "cabin": "economy",
        "refundable": False,
        "dates": {
            "before": "3",
            "after": "3"
        },
        "pax": {
            "ADT": 1,
            "CHD": 0,
            "INF": 0,
            "UNN": 0
        },
        "redempoint": False,
        "pointsBreakup": {
            "option": "",
            "value": 0
        },
        "isMultiCity": False,
        "isDomestic": False
    }
    proxy = f'http://unfflcc:76cc14-47b8dd-1f8ace-827836-0c740e@usa.rotating.proxyrack.net:{int(random.randint(10000, 11149))}'
    # proxy = f'http://unfflcc:76cc14-47b8dd-1f8ace-827836-0c740e@198.147.25.26:{int(random.randint(10000, 11149))}'
    proxy = 'http://user-unifflcc-region-us:q39CEBTs5A5YQXor@pr.roxlabs.cn:4600'
    # proxy = 'http://127.0.0.1:7890'
    session = tls_client.Session(client_identifier='chrome_112')
    session.proxies = {
        'http': proxy,
        'https': proxy,
    }
    print(proxy)
    response = session.post(url, headers=headers, json=data)

    # print(response.text)
    print(response.status_code)
    if response.status_code == 200:
        res = db.env_shape.update_one(
            {'_id': ObjectId(selectId)},
            {"$inc": {"success": 1}}
        )
        # proxy = requests.post('http://ymx-lcc.unififi.com/proxy/get-proxy', json={
        #     'type':'headerB6'
        # })

        uri = 'http://ymx-lcc.unififi.com/header/add'
        proxy = f'http://unfflcc:76cc14-47b8dd-1f8ace-827836-0c740e@usa.rotating.proxyrack.net:{int(random.randint(10000, 11149))}'

        print(selectId, headers)
        r = requests.post(uri, json={
            'brush_fromto': 'LAS-BOS',
            'brush_fromdate': '2023-05-22',
            'brush_header': headers,
            'brush_proxy':proxy,
            'brush_mode':'shopping',
            'brush_name':'js',
            'brush_type':'headerB6',
        })
        print('添加成功')
    # time.sleep(3)
